--- dia-0.85-0/app/disp_callbacks.c	Tue Apr 18 23:19:53 2000
+++ dia-0.85-1/app/disp_callbacks.c	Tue May 23 01:15:53 2000
@@ -38,6 +38,64 @@
 /* This contains the point that was clicked to get this menu */
 static Point object_menu_clicked_point;
 
+#ifdef USE_XIM
+void create_input_dialog (DDisplay *ddisp) {
+  if (gdk_im_ready () && (ddisp->ic_attr = gdk_ic_attr_new ()) != NULL) {
+    gint width, height;
+    GdkColormap *colormap;
+    GdkEventMask mask;
+    GdkICAttr *attr = ddisp->ic_attr;
+    GdkICAttributesType attrmask = GDK_IC_ALL_REQ;
+    GdkIMStyle style;
+    GdkIMStyle supported_style = GDK_IM_PREEDIT_NONE | GDK_IM_PREEDIT_NOTHING |
+      GDK_IM_PREEDIT_POSITION | GDK_IM_STATUS_NONE |
+      GDK_IM_STATUS_NOTHING;
+    if(ddisp->canvas->style && ddisp->canvas->style->font->type != GDK_FONT_FONTSET)
+      supported_style &= ~GDK_IM_PREEDIT_POSITION;
+    attr->style = style = gdk_im_decide_style (supported_style);
+    attr->client_window = ddisp->canvas->window;
+    if((colormap = gtk_widget_get_colormap (ddisp->canvas)) != gtk_widget_get_default_colormap ()) {
+      attrmask |= GDK_IC_PREEDIT_COLORMAP;
+      attr->preedit_colormap = colormap;
+    }
+    switch (style & GDK_IM_PREEDIT_MASK) {
+    case GDK_IM_PREEDIT_POSITION:
+      if(ddisp->canvas->style && ddisp->canvas->style->font->type != GDK_FONT_FONTSET) {
+        g_warning ("ʴѴΥեȤǤޤǤ");
+        break;
+      }
+      attrmask |= GDK_IC_PREEDIT_POSITION_REQ;
+      gdk_window_get_size (ddisp->canvas->window, &width, &height);
+      attr->spot_location.x = 0;
+      attr->spot_location.y = 14;
+      attr->preedit_area.x = 0;
+      attr->preedit_area.y = 0;
+      attr->preedit_area.width = width;
+      attr->preedit_area.height = height;
+      attr->preedit_fontset = ddisp->canvas->style->font;
+      break;
+    }
+    ddisp->ic = gdk_ic_new (attr, attrmask);
+    if(ddisp->ic == NULL) g_warning ("ʴѴѤǤޤ");
+    else {
+      mask = gdk_window_get_events (ddisp->canvas->window);
+      mask |= gdk_ic_get_events(ddisp->ic);
+      gdk_window_set_events (ddisp->canvas->window, mask);
+      gdk_im_begin(ddisp->ic, ddisp->canvas->window);
+    }
+  }
+}
+
+void 
+set_input_dialog(DDisplay *ddisp, int x, int y) {
+  if(ddisp->ic && (gdk_ic_get_style(ddisp->ic) & GDK_IM_PREEDIT_POSITION)) {
+    ddisp->ic_attr->spot_location.x = x;
+    ddisp->ic_attr->spot_location.y = y;
+    gdk_ic_set_attr (ddisp->ic, ddisp->ic_attr, GDK_IC_SPOT_LOCATION);
+  }
+}
+#endif
+
 static void
 object_menu_proxy(GtkWidget *widget, gpointer data)
 {
@@ -196,6 +254,9 @@
   int width, height;
   int new_size;
   int modified;
+#ifdef USE_XIM
+  int x, y;
+#endif
 
   return_val = FALSE;
  
@@ -236,6 +297,12 @@
       break;
 
     case GDK_FOCUS_CHANGE:
+#ifdef USE_XIM
+      if(ddisp->ic == NULL)
+	create_input_dialog (ddisp);
+      else
+	gdk_im_begin(ddisp->ic, ddisp->canvas->window);
+#endif
       diagram_update_menu_sensitivity(ddisp->diagram);
       break;
       
@@ -343,6 +410,10 @@
 	  ObjectChange *obj_change = NULL;
 	
 	  object_add_updates(obj, ddisp->diagram);
+#ifdef USE_XIM
+          ddisplay_transform_coords(ddisp, obj->position.x, obj->position.y, &x, &y);
+	  set_input_dialog(ddisp, x, y);
+#endif
 	  modified = (focus->key_event)(focus, kevent->keyval,
 					kevent->string, kevent->length,
 					&obj_change);
@@ -460,8 +531,15 @@
   if (popup_shell == ddisp->shell) {
     popup_shell = NULL;
   }
-
+#ifdef USE_XIM
+  if (ddisp->ic != NULL) {
+    gdk_ic_destroy (ddisp->ic);
+    ddisp->ic = NULL;
+   }
+  if (ddisp->ic_attr) {
+    gdk_ic_attr_destroy (ddisp->ic_attr);
+    ddisp->ic_attr = NULL;
+  }
+#endif
   ddisplay_really_destroy(ddisp);
 }
-
-
